-------------------------------------------------------------------
--           RAPID - RAPID ADA PORTABLE INTERFACE DESIGNER
--           MCC GUI PACKAGE LIBRARY
--           Copyright (C) 1999 Martin C. Carlisle.
--
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston,
-- MA 02111-1307, USA.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
------------------------------------------------------------------------------

with Gtk.Pixmap;
with Gtk.Widget;
with Gtk.Object;
package peer.Image is
   type String_Pointer is access all String;

   type Mcc_Gtk_Image_Record is new Gtk.Object.Gtk_Object_Record with record
      Filename    : String_Pointer;
      Initialized : Boolean;
      Pixmap      : Gtk.Pixmap.Gtk_Pixmap;
   end record;
   type Mcc_Gtk_Image is access all Mcc_Gtk_Image_Record'Class;

   -- We can't really create a pixmap without having access to the
   -- window.  But we don't in mcc-gui-image, so instead, we can have
   -- that just set up the filename, and do the real processing once
   -- using this initialize
   procedure Initialize
     (Image  : in out Mcc_Gtk_Image_Record;
      Widget : in Gtk.Widget.Gtk_Widget);
end Peer.Image;
