------------------------------------------------------------------------------
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston,
-- MA 02111-1307, USA.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
------------------------------------------------------------------------------
-- Auto generated by RAPID
-- Author : SA Griffin

with Text_IO;
with Ada.Exceptions;
with mcc.Gui.Widget.Text_Entry;
with Subwindow_Actions;
with mcc.Gui.Fonts;
with mcc.Gui.Widget.Button;

package body frame_dialog_window is

   Exception_Occurred : Boolean := False;

   procedure Close_Win is
   begin

      mcc.Gui.Container.Window.Destroy (frame_dialog_window);

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Close_Win " &
            Ada.Exceptions.Exception_Information (E));

   end Close_Win;

   procedure Close_Window (Obj : in out mcc.Gui.Widget.Button.Button'Class) is
   begin

      Close_Win;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Close_Window " &
            Ada.Exceptions.Exception_Information (E));

   end Close_Window;

   procedure Generate_Callback is

   begin

      null;

   end Generate_Callback;

   procedure OK_Win is
   begin

      Generate_Callback;

      if Exception_Occurred then
         -- Don't Close
         null;
      else
         Close_Win;
      end if;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.OK_Win " &
            Ada.Exceptions.Exception_Information (E));

   end OK_Win;

   procedure OK (Obj : in out mcc.Gui.Widget.Button.Button'Class) is
   begin

      OK_Win;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.OK " &
            Ada.Exceptions.Exception_Information (E));

   end OK;

   procedure Generate_Callforward is

      Int_Temp : Integer := 0;

   begin

      null;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Generate_Callforward " &
            Ada.Exceptions.Exception_Information (E));

   end Generate_Callforward;

   procedure Generate_Callforward
     (Obj : in out mcc.Gui.Widget.Button.Button'Class)
   is
   begin

      Generate_Callforward;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           (
"**** EXCEPTION **** : frame_dialog_window.Generate_Callforward-Obj " &
            Ada.Exceptions.Exception_Information (E));

   end Generate_Callforward;

   procedure Generate_Callback
     (Obj : in out mcc.Gui.Widget.Button.Button'Class)
   is
   begin

      Generate_Callback;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Generate_Callback-Obj "
            &
            Ada.Exceptions.Exception_Information (E));

   end Generate_Callback;

   procedure Generate_Window is
   begin

      mcc.Gui.Container.Window.Create
        (Obj    => frame_dialog_window,
         X      => 0,
         Y      => 0,
         Width  => 219,
         Height => 214);

      mcc.Gui.Container.Window.Set_Title
        (Obj   => frame_dialog_window,
         Title => "Frame Properties");

      mcc.Gui.Widget.Label.Create
        (Obj     => label1,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 5,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "Widget name");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => label1,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Label.Create
        (Obj     => label2,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 35,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "X");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => label2,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Label.Create
        (Obj     => label3,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 60,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "Y");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => label3,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Label.Create
        (Obj     => label4,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 85,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "Width");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => label4,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Label.Create
        (Obj     => label5,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 115,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "Height");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => label5,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => entry2,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 35,
         Width  => 100,
         Height => 20);

      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => entry1,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 5,
         Width  => 100,
         Height => 20);

      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => entry3,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 60,
         Width  => 100,
         Height => 20);

      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => entry4,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 85,
         Width  => 100,
         Height => 20);

      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => entry5,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 115,
         Width  => 100,
         Height => 20);

      mcc.Gui.Widget.Button.Text.Create
        (Obj    => applyButton,
         Parent => frame_dialog_window,
         X      => 76,
         Y      => 180,
         Width  => 60,
         Height => 20,
         Text   => "Apply");
      mcc.Gui.Widget.Button.Set_Push_Callback
        (Obj      => applyButton'Access,
         Callback => Subwindow_Actions.Apply_Properties_Dialog'Access);
      mcc.Gui.Widget.Button.Text.Create
        (Obj    => okbutton,
         Parent => frame_dialog_window,
         X      => 10,
         Y      => 180,
         Width  => 60,
         Height => 20,
         Text   => "OK");
      mcc.Gui.Widget.Button.Set_Push_Callback
        (Obj      => okbutton'Access,
         Callback => Subwindow_Actions.Done_Properties_Dialog'Access);
      mcc.Gui.Widget.Button.Text.Create
        (Obj    => cancelButton,
         Parent => frame_dialog_window,
         X      => 141,
         Y      => 180,
         Width  => 60,
         Height => 20,
         Text   => "Cancel");
      mcc.Gui.Widget.Button.Set_Push_Callback
        (Obj      => cancelButton'Access,
         Callback => Subwindow_Actions.Cancel_Properties_Dialog'Access);
      mcc.Gui.Widget.Label.Create
        (Obj     => Border_Lab,
         Parent  => frame_dialog_window,
         X       => 1,
         Y       => 145,
         Width   => 90,
         Height  => 20,
         Justify => mcc.Gui.Widget.Label.Right,
         Text    => "Border Width");
      mcc.Gui.Widget.Label.Set_Foreground_Color
        (Obj       => Border_Lab,
         New_Color => mcc.Gui.Colors.Named_Color (mcc.Gui.Colors.Black));
      mcc.Gui.Widget.Text_Entry.Create
        (Obj    => Border_TE,
         Parent => frame_dialog_window,
         X      => 100,
         Y      => 145,
         Width  => 100,
         Height => 20);

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Generate_Window " &
            Ada.Exceptions.Exception_Information (E));

   end Generate_Window;

   procedure Generate_Window
     (Obj : in out mcc.Gui.Widget.Button.Button'Class)
   is
   begin

      Generate_Window;

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put
           ("**** EXCEPTION **** : frame_dialog_window.Close_Window " &
            Ada.Exceptions.Exception_Information (E));

   end Generate_Window;

end frame_dialog_window;
