---------------------------------------------------------------
--
--  RAPID - Rapid Ada Portable Interface Designer
--
--  CARGV_HELPERS.ADS
--  Description : handles translation of Arguments to Ada
--    TASH procedures.
--
--  Copyright (C) 1999, Martin C. Carlisle <carlislem@acm.org>
--
-- RAPID is free software; you can redistribute it and/or
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.
---------------------------------------------------------------
-- These functions take an argument passed to a Tcl callback and
-- convert it to a type more friendly to Ada.
---------------------------------------------------------------
with CArgv;

package Cargv_Helpers is

   Invalid_Argument : exception;
   Not_Enough_Arguments : exception;

   function Argument
     (Argv   : CArgv.Chars_Ptr_Ptr;
      Number : Integer)
      return   String;

   function Argument
     (Argv   : CArgv.Chars_Ptr_Ptr;
      Number : Integer)
      return   Integer;

end Cargv_Helpers;
