------------------------------------------------------------------------------
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston,
-- MA 02111-1307, USA.
--
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an
-- executable, this unit does not by itself cause the resulting
-- executable to be covered by the GNU General Public License.
-- This exception does not however invalidate any other reasons
-- why the executable file might be covered by the GNU Public
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
--
-- Copyright (C) 2005, SA Griffin <stephen.griffin.external@eads.com>
------------------------------------------------------------------------------

with Text_IO;
with Ada.Exceptions;

package body mcc.Gui.Widget.Frame is

   ------------
   -- Create --
   ------------

   procedure Create
     (Obj          : in out Frame;
      Parent       : in mcc.Gui.Container.Container'Class;
      X            : in Integer;
      Y            : in Integer;
      Width        : in Natural;
      Height       : in Natural;
      Border_Width : in Natural := 1)
   is
      L_BW : Natural := 1;
   begin

      Obj.My_Peer := peer.Create_Peer (mcc.Gui.Object (Parent).My_Peer);
      peer.Eval
        ("frame " & Obj.My_Peer.Name.all &
         " -relief solid -borderwidth " & mcc.Img (L_BW));
      --" -relief solid -borderwidth " & integer'image(border_width));
      peer.Eval
        ("place " & Obj.My_Peer.Name.all &
         " -anchor nw" &
         " -x " & mcc.Img (X) &
         " -y " & mcc.Img (Y) &
         " -width " & mcc.Img (Width) &
         " -height " & mcc.Img (Height));

   exception

      when E : others =>
         Text_IO.New_Line;
         Text_IO.Put (Ada.Exceptions.Exception_Information (E));

   end Create;

end Mcc.Gui.Widget.Frame;
